

public class SyntaxNode {
	// Constants for node types
	public static final int VALUE = 0;
	public static final int SQRT = 1;
	public static final int OP_PLUS = 2, OP_MINUS = 3, OP_MULT = 4, OP_DIV = 5;

	private int nodeType;
	private double value;
	private SyntaxNode left, right;

	/** Value node */
	public SyntaxNode(double val) {
		nodeType = VALUE;
		value = val;
	}

	/** Function/operation node */
	public SyntaxNode(int type) {
		nodeType = type;
	}

	...
}
